Skip to main content
POST
/
chat
/
completions
Error
A valid request URL is required to generate request examples
{
  "id": "<string>",
  "created": 123,
  "model": "<string>",
  "object": "chat.completion",
  "choices": [
    {
      "finish_reason": "stop",
      "index": 123,
      "logprobs": {
        "content": [
          {
            "token": "<string>",
            "logprob": 123,
            "bytes": [
              123
            ],
            "top_logprobs": [
              {
                "token": "<string>",
                "logprob": 123,
                "bytes": [
                  123
                ]
              }
            ]
          }
        ],
        "refusal": [
          {
            "token": "<string>",
            "logprob": 123,
            "bytes": [
              123
            ],
            "top_logprobs": [
              {
                "token": "<string>",
                "logprob": 123,
                "bytes": [
                  123
                ]
              }
            ]
          }
        ]
      },
      "message": {
        "content": "<string>",
        "refusal": "<string>",
        "role": "assistant",
        "tool_calls": [
          {
            "id": "<string>",
            "type": "function",
            "function": {
              "name": "<string>",
              "arguments": "<string>"
            }
          }
        ],
        "annotations": [
          {
            "type": "url_citation",
            "url_citation": {
              "end_index": 123,
              "start_index": 123,
              "url": "<string>",
              "title": "<string>"
            }
          }
        ],
        "audio": {
          "id": "<string>",
          "expires_at": 123,
          "data": "aSDinaTvuI8gbWludGxpZnk=",
          "transcript": "<string>"
        },
        "context": {
          "intent": "<string>",
          "citations": [
            {
              "content": "<string>",
              "title": "<string>",
              "url": "<string>",
              "filepath": "<string>",
              "chunk_id": "<string>",
              "rerank_score": 123
            }
          ]
        },
        "reasoning_content": "<string>"
      },
      "content_filter_results": {}
    }
  ],
  "system_fingerprint": "<string>",
  "prompt_filter_results": [
    {
      "prompt_index": 123,
      "content_filter_results": {
        "prompt_index": 123
      }
    }
  ]
}

Authorizations

api-key
string
header
required

Query Parameters

api-version
enum<string>
default:v1

The explicit Azure AI Foundry Models API version to use for this request. v1 if not otherwise specified.

Available options:
v1,
preview

Body

application/json

The extended request model for chat completions against the Azure OpenAI service. This adds the ability to provide data sources for the On Your Data feature.

messages
object[]
required

A list of messages comprising the conversation so far. Depending on the model you use, different message types (modalities) are supported, like text, images, and audio.

Minimum array length: 1
model
string
required

The model deployment identifier to use for the chat completion request.

metadata
object

Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.

Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.

temperature
number<float> | null
default:1

What sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic. We generally recommend altering this or top_p but not both.

Required range: 0 <= x <= 2
top_p
number<float> | null
default:1

An alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.

We generally recommend altering this or temperature but not both.

Required range: 0 <= x <= 1
user
string

A unique identifier representing your end-user, which can help to monitor and detect abuse.

top_logprobs
integer<int32>

An integer between 0 and 20 specifying the number of most likely tokens to return at each token position, each with an associated log probability.

Required range: 0 <= x <= 20
modalities
any
reasoning_effort
enum<string>
default:medium

o-series models only

Constrains effort on reasoning for reasoning models. Currently supported values are low, medium, and high. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response.

Available options:
low,
medium,
high
max_completion_tokens
integer<int32> | null

An upper bound for the number of tokens that can be generated for a completion, including visible output tokens and reasoning tokens.

frequency_penalty
number<float> | null
default:0

Number between -2.0 and 2.0. Positive values penalize new tokens based on their existing frequency in the text so far, decreasing the model's likelihood to repeat the same line verbatim.

Required range: -2 <= x <= 2
presence_penalty
number<float> | null
default:0

Number between -2.0 and 2.0. Positive values penalize new tokens based on whether they appear in the text so far, increasing the model's likelihood to talk about new topics.

Required range: -2 <= x <= 2
response_format
object

An object specifying the format that the model must output.

Setting to { "type": "json_schema", "json_schema": {...} } enables Structured Outputs which ensures the model will match your supplied JSON schema.

Setting to { "type": "json_object" } enables JSON mode, which ensures the message the model generates is valid JSON.

Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if finish_reason="length", which indicates the generation exceeded max_tokens or the conversation exceeded the max context length.

audio
object

Parameters for audio output. Required when audio output is requested with modalities: ["audio"].

store
boolean | null
default:false

Whether or not to store the output of this chat completion request for use in model distillation or evals products.

stream
boolean | null
default:false

If set to true, the model response data will be streamed to the client as it is generated using server-sent events.

stop

Not supported with latest reasoning models o3 and o4-mini.

Up to 4 sequences where the API will stop generating further tokens. The returned text will not contain the stop sequence.

logit_bias
object

Modify the likelihood of specified tokens appearing in the completion.

Accepts a JSON object that maps tokens (specified by their token ID in the tokenizer) to an associated bias value from -100 to 100. Mathematically, the bias is added to the logits generated by the model prior to sampling. The exact effect will vary per model, but values between -1 and 1 should decrease or increase likelihood of selection; values like -100 or 100 should result in a ban or exclusive selection of the relevant token.

logprobs
boolean | null
default:false

Whether to return log probabilities of the output tokens or not. If true, returns the log probabilities of each output token returned in the content of message.

max_tokens
integer<int32> | null
deprecated

The maximum number of tokens that can be generated in the chat completion. This value can be used to control costs for text generated via API.

This value is now deprecated in favor of max_completion_tokens, and is not compatible with o1 series models.

n
integer<int32> | null
default:1

How many chat completion choices to generate for each input message. Note that you will be charged based on the number of generated tokens across all of the choices. Keep n as 1 to minimize costs.

Required range: 1 <= x <= 128
prediction
object

Configuration for a predicted output, which can greatly improve response times when large parts of the model response are known ahead of time. This is most common when you are regenerating a file with only minor changes to most of the content.

seed
integer<int64> | null

This feature is in Beta. If specified, our system will make a best effort to sample deterministically, such that repeated requests with the same seed and parameters should return the same result. Determinism is not guaranteed, and you should refer to the system_fingerprint response parameter to monitor changes in the backend.

Required range: -9223372036854776000 <= x <= 9223372036854776000
stream_options
object

Options for streaming response. Only set this when you set stream: true.

tools
object[]

A list of tools the model may call. Currently, only functions are supported as a tool. Use this to provide a list of functions the model may generate JSON inputs for. A max of 128 functions are supported.

tool_choice

Controls which (if any) tool is called by the model. none means the model will not call any tool and instead generates a message. auto means the model can pick between generating a message or calling one or more tools. required means the model must call one or more tools. Specifying a particular tool via {"type": "function", "function": {"name": "my_function"}} forces the model to call that tool.

none is the default when no tools are present. auto is the default if tools are present.

Available options:
none,
auto,
required
parallel_tool_calls
boolean
default:true

Whether to enable parallel function calling during tool use.

function_call
deprecated

Deprecated in favor of tool_choice.

Controls which (if any) function is called by the model.

none means the model will not call a function and instead generates a message.

auto means the model can pick between generating a message or calling a function.

Specifying a particular function via {"name": "my_function"} forces the model to call that function.

none is the default when no functions are present. auto is the default if functions are present.

Available options:
none,
auto
functions
object[]
deprecated

Deprecated in favor of tools.

A list of functions the model may generate JSON inputs for.

Required array length: 1 - 128 elements
data_sources
object[]

The data sources to use for the On Your Data feature, exclusive to Azure OpenAI.

user_security_context
object

User security context contains several parameters that describe the application itself, and the end user that interacts with the application. These fields assist your security operations teams to investigate and mitigate security incidents by providing a comprehensive approach to protecting your AI applications. Learn more about protecting AI applications using Microsoft Defender for Cloud.

Response

The request has succeeded.

The extended top-level chat completion response model for the Azure OpenAI service. This model adds Responsible AI content filter annotations for prompt input.

id
string
required

A unique identifier for the chat completion.

created
integer<unixtime>
required

The Unix timestamp (in seconds) of when the chat completion was created.

model
string
required

The model used for the chat completion.

object
enum<string>
required

The object type, which is always chat.completion.

Available options:
chat.completion
choices
object[]
required
system_fingerprint
string

This fingerprint represents the backend configuration that the model runs with.

Can be used in conjunction with the seed request parameter to understand when backend changes have been made that might impact determinism.

usage
object

Usage statistics for the completion request.

prompt_filter_results
object[]

The Responsible AI content filter annotations associated with prompt inputs into chat completions.